#ifndef STORETYPE_QFRAME_H
#define STORETYPE_QFRAME_H

#include <TStoreTypeQWidget.h>

class TStoreTypeQFrame: public TStoreTypeQWidget {
Q_OBJECT
public:
	TStoreTypeQFrame(TStoreType *, TLayoutWindow *);
	QString storeTypeName();
	QString headerFile();

	bool isCreatable();
	bool isVisible();

	void writeHFile(QTextStream &os, QString);
	void writeCFileConstructor(QTextStream &os, QString, QString);
	void writeCFileProperties(QTextStream &os, QString);
	void writeLayout(QTextStream &data, int);
	void readLayoutItem(QTextStream &os, QString);
  
	void copyDetails(TStoreType *oldObj);
protected:
	void addProperties();

	bool QFrameSetLineWidthFunc(QString AValue);
	QString QFrameGetLineWidthFunc();

	bool QFrameSetMidWidthFunc(QString AValue);
	QString QFrameGetMidWidthFunc();

	bool QFrameSetFrameShapeFunc(QString AValue);
	QString QFrameGetFrameShapeFunc();
	void QFrameInitFrameShapeFunc(QObject *);

	bool QFrameSetShadowFunc(QString AValue);
	QString QFrameGetShadowFunc();
	void QFrameInitShadowFunc(QObject *);
private:
};

TStoreType *createStoreTypeQFrame(TStoreType *parent, TLayoutWindow *lw);

#endif /* STORETYPE_QFRAME_H */
